unit uDnslookup; { Testprogramm nach F.Piette, mk, 7.7.05 }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  WSocket, StdCtrls;

type
  TForm1 = class(TForm)
    eEingabe: TEdit; lEingabe: TLabel; mAusgabe: TMemo; bIP_Name: TButton; bName_IP: TButton; bAbbruch: TButton;
    procedure bIP_NameClick(Sender: TObject);
    procedure bAbbruchClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure socketDnsLookupDone(Sender: TObject; Error: Word);
    procedure bName_IPClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    socket : TWSocket;
    FError : Word;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  // Erzeugung
  socket := TWSocket.Create(nil);
  // Ereigniss mit Ereignisbehandlung verbinden
  socket.OnDnsLookupDone := socketDnsLookupDone;

  bIP_Name.Enabled := true;        // Button auf enable
  bName_IP.Enabled := true;        // Button auf enable
  bAbbruch.Enabled := false;       // Button auf disable
  ActiveControl := eEingabe;       // Fokus auf eEingabe
  eEingabe.Text := LocalHostName;  // LocalHostName in Unit WSocket
  eEingabe.SelectAll;              // alles markieren
  mAusgabe.Lines := LocalIPList;   // LocalIPList in Unit WSocket
end;

procedure TForm1.bIP_NameClick(Sender: TObject);
begin
  bIP_Name.Enabled := false;
  bName_IP.Enabled := false;
  bAbbruch.Enabled := true;
  socket.ReverseDnsLookup(eEingabe.text);         // ics
  mAusgabe.Lines.add('Suche nach Name luft ...');
end;

procedure TForm1.bName_IPClick(Sender: TObject);
begin
  bIP_Name.Enabled := false;
  bName_IP.Enabled := false;
  bAbbruch.Enabled := true;
  socket.DnsLookup(eEingabe.text);                // ics
  mAusgabe.Lines.add('Suche nach IP luft ...');
end;

// Ereignisbehandlungsroutine von WSocket1

procedure TForm1.socketDnsLookupDone(Sender: TObject; Error: Word);
begin
  if Error = 0
  then mAusgabe.Lines := socket.DnsResultList     // ics
  else mAusgabe.Lines.add('Fehlernummer =' + IntToStr(Error));
  bIP_Name.Enabled := true;
  bName_IP.Enabled := true;
  bAbbruch.Enabled := false;
end;

procedure TForm1.bAbbruchClick(Sender: TObject);
begin
  socket.CancelDnsLookup;                     // ics, Suche aufgeben
  bIP_Name.Enabled := true;
  bName_IP.Enabled := true;
  bAbbruch.Enabled := false;
  ActiveControl    := eEingabe;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  socket.free;
end;

end.


